SystemOrganization addCategory: #'Idiom-Exercise'!

Object subclass: #BlockProfiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Idiom-Exercise'!

!BlockProfiler methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 5/18/2012 21:08'!
timeTrack: aBlock
| millisecondsBeforeRunning  millisecondsAfterRunning |
	millisecondsBeforeRunning := Time millisecondClockValue.
	aBlock value.
	millisecondsAfterRunning := Time millisecondClockValue.
	^millisecondsAfterRunning-millisecondsBeforeRunning.

! !

!BlockProfiler methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 5/18/2012 21:07'!
timeTrack: aBlock assertBelow: aMillisecondsClockValue
	^self assert: (self timeTrack: aBlock) < aMillisecondsClockValue.
! !

!BlockProfiler methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 5/18/2012 21:17'!
when: aBlock catchError: anError handleWith: anErrorBlock

	[aBlock value. self fail]
		on: anError
		do: anErrorBlock ! !

Object subclass: #CustomerBook
	instanceVariableNames: 'customers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Idiom-Exercise'!

!CustomerBook class methodsFor: 'error messages' stamp: 'HernanWilkinson 7/6/2011 17:57'!
customerAlreadyExistsErrorMessage

	^'Customer already exists'! !

!CustomerBook class methodsFor: 'error messages' stamp: 'HernanWilkinson 7/6/2011 17:53'!
customerCanNotBeEmptyErrorMessage

	^'Customer name cannot be empty'! !

!CustomerBook methodsFor: 'customer management' stamp: 'HernanWilkinson 7/6/2011 17:42'!
addCustomerNamed: aName

	aName isEmpty ifTrue: [ self signalCustomerNameCannotBeEmpty ].
	(customers includes: aName) ifTrue: [ self signalCustomerAlreadyExists ].
	
	customers add: aName ! !

!CustomerBook methodsFor: 'testing' stamp: 'HernanWilkinson 7/6/2011 17:56'!
includesCustomerNamed: aName

	^customers includes: aName ! !

!CustomerBook methodsFor: 'initialization' stamp: 'HernanWilkinson 7/6/2011 17:42'!
initialize

	super initialize.
	customers := OrderedCollection new! !

!CustomerBook methodsFor: 'testing' stamp: 'HernanWilkinson 7/6/2011 17:48'!
isEmpty
	
	^customers isEmpty  ! !

!CustomerBook methodsFor: 'customer management' stamp: 'HernanWilkinson 7/6/2011 17:56'!
numberOfCustomers
	
	^customers size! !

!CustomerBook methodsFor: 'customer management' stamp: 'HernanWilkinson 7/6/2011 17:44'!
removeCustomerNamed: aName
 
	customers remove: aName ! !

!CustomerBook methodsFor: 'customer management' stamp: 'HernanWilkinson 7/6/2011 17:52'!
signalCustomerAlreadyExists 

	self error: self class customerAlreadyExistsErrorMessage! !

!CustomerBook methodsFor: 'customer management' stamp: 'HernanWilkinson 7/6/2011 17:51'!
signalCustomerNameCannotBeEmpty 

	self error: self class customerCanNotBeEmptyErrorMessage ! !

TestCase subclass: #IdiomTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Idiom-Exercise'!

!IdiomTest methodsFor: 'testing' stamp: 'GabrielBursztyn 5/18/2012 21:14'!
test01AddingCustomerShouldNotTakeMoreThan50Milliseconds

	| customerBook millisecondsBeforeRunning millisecondsAfterRunning|
	
	customerBook := CustomerBook  new.
	BlockProfiler new timeTrack: [customerBook addCustomerNamed: 'John Lennon'.] assertBelow: 50.
	
! !

!IdiomTest methodsFor: 'testing' stamp: 'GabrielBursztyn 5/18/2012 21:14'!
test02RemovingCustomerShouldNotTakeMoreThan100Milliseconds

	| customerBook millisecondsBeforeRunning millisecondsAfterRunning johnLennon |
	
	customerBook := CustomerBook  new.
	johnLennon := 'John Lennon'.
	
	customerBook addCustomerNamed: johnLennon.
	
	BlockProfiler new timeTrack: [customerBook removeCustomerNamed: johnLennon.] assertBelow: 100.
	
	
! !

!IdiomTest methodsFor: 'testing' stamp: 'GabrielBursztyn 5/18/2012 21:17'!
test03CanNotAddACustomerWithEmptyName 

	| customerBook |
			
	customerBook := CustomerBook new.

	BlockProfiler new when: [customerBook addCustomerNamed: '']
		 catchError: Error
		 handleWith: [ :anError | 
				self assert: anError messageText = CustomerBook customerCanNotBeEmptyErrorMessage.
				self assert: customerBook isEmpty ].! !

!IdiomTest methodsFor: 'testing' stamp: 'GabrielBursztyn 5/18/2012 21:17'!
test04CanNotAddRepeatedCustomer 
	
	| customerBook johnLennon |
			
	customerBook := CustomerBook new.
	johnLennon := 'John Lennon'.
	customerBook addCustomerNamed: johnLennon.
	
	BlockProfiler new when: [ customerBook removeCustomerNamed: 'Paul McCartney']
		 catchError: NotFound
		 handleWith: [ :anError | 
				self assert: customerBook numberOfCustomers = 1.
				self assert: (customerBook includesCustomerNamed: johnLennon) ].
! !
